unit Demodulator;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, MtxBaseComp, SignalTools, SignalAnalysis, SignalToolsDialogs,
  SpectrumAna, TeeProcs, TeEngine, Chart, SignalToolsTee, StdCtrls,
  ExtCtrls, FileSignal, Series, SignalSeriesTee, TeeTools, TeeEdit,
  SignalProcessing, MtxVec, MtxComCtrls, MtxDialogs, ComCtrls, ToolWin;

type
  TDemodulatorForm = class(TForm)
    SpectrumAnalyzerDialog1: TSpectrumAnalyzerDialog;
    SignalRead1: TSignalRead;
    ChartEditor1: TChartEditor;
    SG1: TSignalDemodulator;
    SpectrumAnalyzer1: TSpectrumAnalyzer;
    SpectrumAnalyzer3: TSpectrumAnalyzer;
    RichEdit1: TRichEdit;
    Panel2: TPanel;
    ToolBar1: TToolBar;
    SpectrumEditButton: TToolButton;
    ChartEditButton: TToolButton;
    Label1: TLabel;
    MtxFloatEdit1: TMtxFloatEdit;
    Label2: TLabel;
    MtxFloatEdit2: TMtxFloatEdit;
    Panel1: TPanel;
    SpectrumChart2: TSpectrumChart;
    FastLineSeries1: TFastLineSeries;
    SignalDiscreteSeries1: TSignalDiscreteSeries;
    AxisScaleTool1: TAxisScaleTool;
    Splitter2: TSplitter;
    SpectrumChart3: TSpectrumChart;
    FastLineSeries2: TFastLineSeries;
    SignalDiscreteSeries2: TSignalDiscreteSeries;
    AxisScaleTool2: TAxisScaleTool;
    procedure FormCreate(Sender: TObject);
    procedure SpectrumAnalyzer1ParameterUpdate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure MtxFloatEdit1Change(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure ChartEditButtonClick(Sender: TObject);
    procedure SpectrumEditButtonClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DemodulatorForm: TDemodulatorForm;

implementation

{$R *.dfm}

procedure TDemodulatorForm.FormCreate(Sender: TObject);
begin
     SignalRead1.FileName := ExtractFileDir(Application.ExeName) + '\bz.sfs';
     With RichEdit1.Lines, RichEdit1 do
     begin
        Clear;
        Add('TSignalDemodulator component moves the selected bandwidth down to 0Hz. ' +
            'The component features multi-rate, multi-stage decimation which allows ' +
            'demodulation of very narrow frequency bands (less then 0.01% of original bandwidth ' +
            'is not a problem). In the example below you can change the Frequency and Bandwidth ' +
            'parameters. Bandwidth change will have effect only when the change made will ' +
            'result in sampling frequency reduction/increase by 2x. Both frequency and bandwidth are '+
            'defined in radians and must range between 0 and 0.5 and frequency + bandwidth may not be bigger then 0.5. '+ 
            'The component also allows you to sample with sampling frequency of 44.1Khz directly from ' +
            'the sound card and have a real time frequency spectrum display of bandwidth between 20 and 20.1 Khz ' +
            'with frequency resolution of 1 mHz (for example).');
        Paragraph.FirstIndent := 0;
        Paragraph.Numbering := nsNone;
    end;
    SignalRead1.RecordPosition := 0;
    SpectrumAnalyzer1.Pull;
    SpectrumAnalyzer1.Pull;
    SpectrumAnalyzer3.Update;
end;

procedure TDemodulatorForm.SpectrumAnalyzer1ParameterUpdate(Sender: TObject);
begin
    SpectrumAnalyzer1.Update;
    SpectrumAnalyzer3.Update;
end;

procedure TDemodulatorForm.Button3Click(Sender: TObject);
var SG1: TSignalDemodulator;
begin
    SG1 := TSignalDemodulator.Create(Self);
    SG1.SubBandFrequency := 0.25;
    SG1.SubBandWidth := 0.25;
    SG1.Destroy;
end;

procedure TDemodulatorForm.MtxFloatEdit1Change(Sender: TObject);
begin
     SG1.SubBandFrequency := MtxFloatEdit1.Position;
     SG1.SubBandWidth := MtxFloatEdit2.Position;
     SignalRead1.RecordPosition := 0;
     SpectrumAnalyzer1.Pull;
     SpectrumAnalyzer1.Pull;
     SpectrumAnalyzer3.Update;
end;

procedure TDemodulatorForm.FormResize(Sender: TObject);
begin
     SpectrumChart3.Height := Panel1.Height div 2;
end;

procedure TDemodulatorForm.ChartEditButtonClick(Sender: TObject);
begin
    ChartEditor1.Execute;
end;

procedure TDemodulatorForm.SpectrumEditButtonClick(Sender: TObject);
begin
     SpectrumAnalyzerDialog1.Execute();
end;

initialization
RegisterClass(TDemodulatorForm);

end.
